// coded by scarebyte (uCF)
// mail: scarebyte@youceff.com
//
// application: x3chun's Crypto KeyGenMe #1
// url:         http://www.x3chun.wo.to/
// protection:  md5, sha-1, haval-256, rsa-350
// uses:        MD5, SHA1, HAVAL, FGInt


const
// change this constants for the keygen
// Labels
 lb_appname  = 'uCF - x3chun''s Crypto KeyGenMe #1';
 lb_done     = 'keygen done by scarebyte';
 lb_name     = 'Name:';
 lb_comp     = 'Company:';
// Editfields
 ed_name     = 'not used';
 ed_comp     = 'uCF';
// Conditions 
 Name_used   = true;
 Comp_used   = true;
 genonchange = true;

// key - routine

(***************************************************************)
function UpperCase(const S: string): string;
var Ch           : Char;
    L            : Integer;
    Source, Dest : PChar;
begin
  L := Length(S);
  SetLength(Result, L);
  Source := Pointer(S);
  Dest := Pointer(Result);
  while L <> 0 do begin
        Ch := Source^;
        if (Ch >= 'a') and (Ch <= 'z') then Dec(Ch, 32);
        Dest^ := Ch;
        Inc(Source);
        Inc(Dest);
        Dec(L);
        end;
end;
(***************************************************************)
function int2hex(c: cardinal): string;
const ctab = '0123456789ABCDEF';
begin
 if c shr 4 = 0
    then int2hex := ctab[(c mod 16) + 1]
    else int2hex := int2hex(c shr 4) + ctab[(c mod 16) + 1];
end;
(***************************************************************)
function fillstr(s: string; c: char; pos, digits: byte): string;
begin
 result := s;
 while length(result) <> digits do
       insert(c, result, pos);
end;
(***************************************************************)
function generate(uName, uMail: string): string;
var i, x, len   : integer;
    temp        : string;
    buffer      : array[0..39] of byte;
    // sha-1
    sha_context : TSHA1Context;
    sha_digest  : TSHA1Digest;
    // md5
    md5_context : TMD5Context;
    md5_digest  : TMD5Digest;
    // haval 256
    hav_context : THavalCtx;
    // rsa
    c, d, m, n  : TFGInt;

const magic: array[0..7] of string = (
             'BfUpNpdP3ApLaxIr0yto', 'MIjhBlDxcD7biA84iAR0',
             'DJYdez6hAgiZkhOpsdML', 'I74d7OB6sMoM698tKFoY',
             'TLzm4ueUoZ48kXs4QJKo', 'Shg1WL8EqwJPg4rofFkP',
             'D53JUPEsrHrJ0t5yZl1x', 'MhU0o1xo7IN2laFLbgFY');
begin

  // concat both strings
  temp := uName + uMail;

  // SHA-1 hash
  SHA1Init(sha_context);
  SHA1Update(sha_context, pchar(temp), length(temp));
  SHA1Final(sha_context, sha_digest);

  // move result to buffer
  move(sha_digest, buffer, sizeof(sha_digest));

  // get magic string and put them to end of buffer
  if sha_digest[0] = 0
     then x := 0
     else x := (sha_digest[0]-1) div $20;
  for i := 1 to length(magic[x]) do buffer[i+19] := byte(magic[x, i]);

  // md5 loop
  for i := $100 downto $1 do begin
      for len := 0 to (sizeof(buffer)-1) do if buffer[len] = 0 then break;
      MD5Init(md5_context);
      MD5Update(md5_context, buffer, len);
      MD5Final(md5_digest, md5_context);
      move(md5_digest, buffer, sizeof(md5_digest));
      buffer[$10] := 0;
      end;

  // haval 256
  HavalInit(hav_context);
  HavalUpdate(hav_context, @buffer, $10, 3);
  temp := uppercase(HavalFinal(hav_context, 3, 256));

  if temp[1] = '0'
     then begin
          result := 'no serial for this name';
          exit;
          end;

  // rsa
  ConvertHexStringToBase256String(temp, temp);
  Base256StringToFGInt(temp, c);
  Base10StringToFGInt('1256999810287721585587379048569008578748297833782713742720085108575305825883648159979687095493369087715481', n);
  Base10StringToFGInt('737758788206924497453629783224848787426236723933840140701634427965920282958629177912259580412714179583013',  d);
  FGIntModExp(c, d, n, m);
  FGIntToBase256String(m, temp);
  ConvertBase256StringToHexString(temp, result);
  FGIntDestroy(c);  FGIntDestroy(d);
  FGIntDestroy(m);  FGIntDestroy(n);

end;
(***************************************************************)


// read textfields

procedure GenGoodCode;
var Text, Text2  : pchar;
    Lang, Lang2  : integer;
begin

 Lang  := GetWindowTextLengthA(txtField1);
 Lang2 := GetWindowTextLengthA(txtField2);

 if (Lang > 2) and (Lang2 > 2) then begin
    GetMem (Text, Lang + 1);
    GetWindowTextA (txtField1, Text, Lang + 1);

    GetMem (Text2, Lang2 + 1);
    GetWindowTextA (txtField2, Text2, Lang2 + 1);

    SetWindowText(txtGoodCode,PChar(generate(Text, Text2)));

    FreeMem(Text,  Lang + 1);
    FreeMem(Text2, Lang2 + 1);
    End
 else
    SetWindowText(txtGoodCode, 'I need more letters ...');
end;